#ifndef cci_SOSI
#define cci_SOSI 1

#include "cci_use.h"
#include "knl_sos.h"
#include "agg_sos.h"
#include "mta_sos.h"
class _cci_Schema_impl;
class _cci_Method_impl;
class _cci_Schema_impl:virtual public _sos_Schema_impl
{  friend class cci_Schema_impl;
   virtual sos_Offset _offset_sos_Object () { return 0; }
   virtual sos_Offset _offset_sos_Schema_impl () { return 8; }
   virtual sos_Offset _offset_cci_Schema_impl () { return 8; }
public:
   static _cci_Schema_impl* _make(sos_Typed_id&);
   virtual sos_Offset _size();
   void _create(sos_Typed_id&);
   void _copy(sos_Typed_id&,cci_Schema_impl);
   virtual sos_Object _clone(sos_Typed_id&,sos_Container);
   virtual void destroy(sos_Typed_id&);
   virtual void assign(sos_Typed_id&,sos_Object);
   virtual sos_Bool equal(sos_Typed_id&,sos_Object,sos_Eq_kind=EQ_STRONG);
   static sos_Bool local_equal(cci_Schema_impl,sos_Object,sos_Eq_kind);
   virtual sos_Int hash_value(sos_Typed_id&);
   static sos_Int local_hash_value(cci_Schema_impl);
   virtual void load(sos_Typed_id&);
   virtual sos_String_List get_object_files(sos_Typed_id&);
   virtual void set_object_files(sos_Typed_id&,sos_String_List);
   virtual sos_String_List get_libraries(sos_Typed_id&);
   virtual void set_libraries(sos_Typed_id&,sos_String_List);
   virtual sos_String_List get_schemas(sos_Typed_id&);
   virtual void set_schemas(sos_Typed_id&,sos_String_List);
   static cci_Schema_impl make_impl(sos_Schema_module _p1);
   static cci_Make_obj get_make_obj(sos_Id _p1,sos_Id _p2);
   static void enter_make_obj(sos_Id _p1,sos_Id _p2,cci_Make_obj _p3);
   static cci_Fun get_fun(sos_Id _p1);
   static void enter_fun(sos_Id _p1,cci_Fun _p2);
   static void enter_string_io(sos_Id _p1,cci_IO_fun _p2,cci_IO_fun _p3);
   static sos_Object extern_object_from_string(sos_Type _p1,sos_String _p2);
   static sos_String string_from_extern_object(sos_Object _p1);
protected:
   static void local_assign(cci_Schema_impl _p1,sos_Object _p2);
   static void local_initialize(cci_Schema_impl _p1);
   static void local_finalize(cci_Schema_impl _p1);
};
extern _cci_Schema_impl *__cci_Schema_impl_obj;
class _cci_Method_impl:virtual public _sos_Method_impl
{  friend class cci_Method_impl;
   virtual sos_Offset _offset_sos_Object () { return 0; }
   virtual sos_Offset _offset_sos_Method_impl () { return 8; }
   virtual sos_Offset _offset_cci_Method_impl () { return 8; }
public:
   static _cci_Method_impl* _make(sos_Typed_id&);
   virtual sos_Offset _size();
   void _create(sos_Typed_id&);
   void _copy(sos_Typed_id&,cci_Method_impl);
   virtual sos_Object _clone(sos_Typed_id&,sos_Container);
   virtual void destroy(sos_Typed_id&);
   virtual void assign(sos_Typed_id&,sos_Object);
   static void local_assign(cci_Method_impl,sos_Object);
   virtual sos_Bool equal(sos_Typed_id&,sos_Object,sos_Eq_kind=EQ_STRONG);
   static sos_Bool local_equal(cci_Method_impl,sos_Object,sos_Eq_kind);
   virtual sos_Int hash_value(sos_Typed_id&);
   static sos_Int local_hash_value(cci_Method_impl);
   virtual void enter_fun(sos_Typed_id&,cci_Fun _p1);
   virtual sos_Object execute(sos_Typed_id&,sos_Object _p1,sos_Object_Array _p2);
   static sos_String operator_string(sos_String _p1);
   static cci_Method_impl make_impl(sos_Method _p1);
protected:
};
extern _cci_Method_impl *__cci_Method_impl_obj;
extern void _cci_init_sos();
#endif
